package AccordionBus;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.util.Random;

public class AccordionBusForm {
    public DrawingBus drawingBus;
    private AbstractStrategy abstractStrategy;

    private JPanel pictureBox;
    public JPanel getPictureBox() {
        return pictureBox;
    }
    private JPanel createPanel;
    private JButton buttonCreateAccordionBus;
    private JPanel movePanel;
    private JButton buttonLeft;
    private JButton buttonDown;
    private JButton buttonRight;
    private JButton buttonUp;
    private JPanel strategyPanel;
    private JPanel controlPanel;
    private JButton buttonCreateBus;
    private JComboBox comboBoxStrategy;
    private JButton buttonStep;
    public JButton buttonSelectBus;

    public AccordionBusForm() {
        buttonUp.setName("buttonUp");
        buttonDown.setName("buttonDown");
        buttonLeft.setName("buttonLeft");
        buttonRight.setName("buttonRight");

        comboBoxStrategy.addItem("MoveToCenter");
        comboBoxStrategy.addItem("MoveToBorder");

        buttonCreateAccordionBus.addActionListener(e -> {
            Random random = new Random();
            Color bodyColor = JColorChooser.showDialog(this.pictureBox, "Выберите цвет", Color.BLACK);
            Color additionalColor = JColorChooser.showDialog(this.pictureBox, "Выберите дополнительный цвет", Color.BLACK);
            drawingBus = new DrawingAccordionBus(random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    bodyColor,
                    additionalColor,
                    random.nextBoolean(),
                    random.nextBoolean(),
                    pictureBox.getWidth(),
                    pictureBox.getHeight());
            drawingBus.SetPosition(random.nextInt(10, 100),
                    random.nextInt(10, 100));
            Draw();
        });

        buttonCreateBus.addActionListener(e -> {
            Random random = new Random();
            Color bodyColor = JColorChooser.showDialog(this.pictureBox, "Выберите цвет", Color.BLACK);
            drawingBus = new DrawingBus(random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    bodyColor,
                    pictureBox.getWidth(),
                    pictureBox.getHeight());
            drawingBus.SetPosition(random.nextInt(10, 100),
                    random.nextInt(10, 100));
            Draw();
        });

        ActionListener buttonMoveClickedListener = e -> {
            String name = ((JButton)e.getSource()).getName();
            switch (name) {
                case "buttonUp" -> {
                    drawingBus.MoveTransport(DirectionType.Up);
                }
                case "buttonDown" -> {
                    drawingBus.MoveTransport(DirectionType.Down);
                }
                case "buttonLeft" -> {
                    drawingBus.MoveTransport(DirectionType.Left);
                }
                case "buttonRight" -> {
                    drawingBus.MoveTransport(DirectionType.Right);
                }
            }
            Draw();
        };

        buttonStep.addActionListener(e -> {
            if (drawingBus == null) {
                return;
            }

            if (comboBoxStrategy.isEnabled()) {
                switch (comboBoxStrategy.getSelectedIndex()) {
                    case 0:
                        abstractStrategy = new MoveToCenter();
                        break;
                    case 1:
                        abstractStrategy = new MoveToBorder();
                        break;
                    default:
                        abstractStrategy = null;
                        break;
                }

                if (abstractStrategy == null) {
                    return;
                }

                abstractStrategy.SetData(new DrawingObjectBus(drawingBus),
                        pictureBox.getWidth(),
                        pictureBox.getHeight());
                comboBoxStrategy.setEditable(false);
            }

            if (abstractStrategy == null) {
                return;
            }

            abstractStrategy.MakeStep();
            Draw();
            if (abstractStrategy.GetStatus() == Status.Finish) {
                comboBoxStrategy.setEnabled(true);
                abstractStrategy = null;
            }
        });

        buttonUp.addActionListener(buttonMoveClickedListener);
        buttonDown.addActionListener(buttonMoveClickedListener);
        buttonLeft.addActionListener(buttonMoveClickedListener);
        buttonRight.addActionListener(buttonMoveClickedListener);
    }

    public void Draw() {
        if (drawingBus == null) {
            return;
        }

        Graphics g = pictureBox.getGraphics();
        pictureBox.paint(g);
        drawingBus.DrawTransport(g);
    }
}
