package AccordionBus;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class BusGenericForm {
    private DrawingBus drawingBus;
    private SetBusGeneric<EntityBus, IDrawingDoors> _busGeneric;

    private JPanel pictureBox;
    public JPanel getPictureBox() {
        return pictureBox;
    }
    private JButton buttonGenerateBus;

    // Конструктор
    public BusGenericForm() {
        _busGeneric = new SetBusGeneric<>(15, 15);

        buttonGenerateBus.addActionListener(e -> {
            addEntityBus();
            addDrawingDoors();

            drawingBus = _busGeneric.NewBus(pictureBox.getWidth(), pictureBox.getHeight());
            drawingBus.SetPosition((pictureBox.getWidth() - drawingBus.GetWidth()) / 2, (pictureBox.getHeight() - drawingBus.GetHeigth()) / 2);
            Draw();
        });
    }

    // Добавить объект-сущность в набор
    private void addEntityBus() {
        Random random = new Random();
        EntityBus entityBus;

        if (random.nextBoolean()) {
            entityBus = new EntityBus(random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)));
        }
        else {
            entityBus = new EntityAccordionBus(random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    random.nextBoolean(),
                    random.nextBoolean());
        }

        _busGeneric.Insert(entityBus);
    }

    // Добавить тип отрисовки дверей в набор
    public void addDrawingDoors() {
        Random random = new Random();
        IDrawingDoors drawingDoors;

        switch (random.nextInt(0, 3)) {
            case 0:
                drawingDoors = new DrawingDoorsTypeOne();
                break;
            case 1:
                drawingDoors = new DrawingDoorsTypeTwo();
                break;
            case 2:
                drawingDoors = new DrawingDoorsTypeThree();
                break;
            default:
                drawingDoors = new DrawingDoorsTypeOne();
                break;
        }
        drawingDoors.setNumDoors(random.nextInt(3, 6));

        _busGeneric.Insert(drawingDoors);
    }

    public void Draw() {
        if (drawingBus == null) {
            return;
        }

        Graphics g = pictureBox.getGraphics();
        pictureBox.paint(g);
        drawingBus.DrawTransport(g);
    }
}
