package AccordionBus;

import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

// Класс для хранения коллекции
public class BusGenericStorage {
    // Словарь (хранилище)
    final HashMap<String, BusGenericCollection<DrawingBus, DrawingObjectBus>> _busStorages;

    // Возвращение списка названий наборов
    public List<String> Keys() {
        return _busStorages.keySet().stream().collect(Collectors.toList());
    }

    // Ширина окна отрисовки
    private final int _pictureWidth;

    // Высота окна отрисовки
    private final int _pictureHeight;

    // Конструктор
    public BusGenericStorage(int pictureWidth, int pictureHeight) {
        _busStorages = new HashMap<String, BusGenericCollection<DrawingBus, DrawingObjectBus>>();
        _pictureWidth = pictureWidth;
        _pictureHeight = pictureHeight;
    }

    // Добавление набора
    public void AddSet(String name) {
        _busStorages.put(name, new BusGenericCollection<DrawingBus, DrawingObjectBus>(_pictureWidth, _pictureHeight));
    }

    // Удаление набора
    public void DelSet(String name) {
        // Проверка наличия ключа
        if (!_busStorages.containsKey(name)) {
            return;
        }

        _busStorages.remove(name);
    }

    // Доступ к набору
    public BusGenericCollection<DrawingBus, DrawingObjectBus> get(String ind) {
        // Проверка наличия ключа
        if (_busStorages.containsKey(ind)) {
            return _busStorages.get(ind);
        }
        return null;
    }

    // Доступ к объекту из набору
    public DrawingObjectBus get(String ind1, int ind2) {
        // Проверка наличия ключа
        if (_busStorages.containsKey(ind1)) {
            return _busStorages.get(ind1).GetU(ind2);
        }
        return null;
    }
}
