package AccordionBus;

import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

// Класс для реализации поддержки передачи данных типа Color
public class ColorTransferable implements Transferable {
    private Color color;
    public static final DataFlavor colorDataFlavor = new DataFlavor(Color.class, "Color");

    public ColorTransferable(Color color) {
        this.color = color;
    }

    @Override
    public DataFlavor[] getTransferDataFlavors() {
        return new DataFlavor[] {colorDataFlavor};
    }

    @Override
    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return colorDataFlavor.equals(flavor);
    }

    @Override
    public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
        if (isDataFlavorSupported(flavor)) {
            return color;
        }
        else {
            throw new UnsupportedFlavorException(flavor);
        }
    }
}
