package AccordionBus;

import javax.swing.*;
import java.awt.datatransfer.Transferable;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

// Класс для создания компонента DrawingDoors для формы
public class DoorComponent extends JComponent {
    public IDrawingDoors DrawingDoors;

    public DoorComponent(IDrawingDoors drawingDoors) {
        DrawingDoors = drawingDoors;

        this.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent e) {
                ((DoorComponent)e.getComponent()).getTransferHandler().exportAsDrag(((DoorComponent)e.getComponent()), e, TransferHandler.COPY);
            }
        });

        this.setTransferHandler(new TransferHandler() {
            @Override
            public int getSourceActions(JComponent c) {
                return TransferHandler.COPY;
            }

            @Override
            protected Transferable createTransferable(JComponent c) {
                return new IDrawingDoorsTransferable(((DoorComponent)c).DrawingDoors);
            }
        });
    }
}
